/*
 * Copyright 2016-present Open Networking Laboratory
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.onosproject.nemo.model.intent.structure.style.nemo.delete.input;

import org.onosproject.nemo.model.common.ConnectionId;
import org.onosproject.nemo.model.common.FlowId;
import org.onosproject.nemo.model.common.NodeId;

import java.util.List;

/**
 * Representation of objects.
 */
public interface Objects {

    /**
     * Returns a list of node identifiers.
     *
     * @return the list of node IDs
     */
    List<NodeId> getNodeIds();

    /**
     * Returns a list of connection identifiers.
     *
     * @return the list of connection IDs
     */
    List<ConnectionId> getConnectionIds();

    /**
     * Returns a list of flow identifiers.
     *
     * @return the list of flow IDs
     */
    List<FlowId> getFlowIds();
}