package org.onosproject.nemo.model.object.match.item.definitions;
import static org.junit.Assert.assertEquals;

import org.junit.Test;
import org.onosproject.nemo.model.common.MatchItemName;

import com.google.common.testing.EqualsTester;

/**
 * Unit tests for {@link MatchItemDefinitionKey}.
 */
public class MatchItemDefinitionKeyTest {

    private static final String NAME = "SomeName";
    private static final String OTHER = "OtherName";
    private static final String NAME_ERROR_MSG = "name not set";

    private MatchItemDefinitionKey source;
    private MatchItemDefinitionKey copy;
    private MatchItemDefinitionKey diff;

    @Test
    public void fromMatchItemName() {
        source = new MatchItemDefinitionKey(new MatchItemName(NAME));
        assertEquals(NAME_ERROR_MSG, NAME,
                source.getMatchItemName().getValue());
    }

    @Test
    public void copyConstructor() {
        source = new MatchItemDefinitionKey(new MatchItemName(NAME));
        copy = new MatchItemDefinitionKey(source);
        new EqualsTester()
                .addEqualityGroup(source, copy)
                .testEquals();
    }

    @Test
    public void equality() {
        source = new MatchItemDefinitionKey(new MatchItemName(NAME));
        copy = new MatchItemDefinitionKey(new MatchItemName(NAME));
        diff = new MatchItemDefinitionKey(new MatchItemName(OTHER));
        new EqualsTester()
                .addEqualityGroup(source, copy)
                .addEqualityGroup(diff)
                .testEquals();
    }
}
