package org.onosproject.nemo.model.object.node.definitions;
import static org.junit.Assert.assertEquals;

import org.junit.Test;
import org.onosproject.nemo.model.common.NodeType;
import com.google.common.testing.EqualsTester;

/**
 * Unit tests for {@link NodeDefinitionKey}.
 */
public class NodeDefinitionKeyTest {

    private static final String TYPE = "SomeType";
    private static final String OTHER = "OtherType";
    private static final String TYPE_ERROR_MSG = "type not set";

    private NodeDefinitionKey key;
    private NodeDefinitionKey copy;
    private NodeDefinitionKey diff;

    @Test
    public void fromNodeType() {
        key = new NodeDefinitionKey(new NodeType(TYPE));
        assertEquals(TYPE_ERROR_MSG, TYPE, key.getNodeType().getValue());
    }

    @Test
    public void copyConstructor() {
        key = new NodeDefinitionKey(new NodeType(TYPE));
        copy = new NodeDefinitionKey(key);
        new EqualsTester()
                .addEqualityGroup(key, copy)
                .testEquals();
    }

    @Test
    public void equality() {
        key = new NodeDefinitionKey(new NodeType(TYPE));
        copy = new NodeDefinitionKey(new NodeType(TYPE));
        diff = new NodeDefinitionKey(new NodeType(OTHER));
        new EqualsTester()
                .addEqualityGroup(key, copy)
                .addEqualityGroup(diff)
                .testEquals();
    }
}